// ******************************************************
// *			 	      		        *
// * TEST PER add_point_feature() e point_abstraction() *
// *				     		        *
// ******************************************************

#include <CGAL/Cartesian.h>
#include <CGAL/Homogeneous.h>

// Rappresentazione dei punti:
// Cint = coordinate cartesiane double in rappresentazione cartesiana.
typedef CGAL_Cartesian<double> Cdouble;

#include <peg2_info.h>
#include <peg2.h>

// Per comodita' ...
typedef vertex_2_info<Cdouble,NIL> v_info;
typedef edge_2_info<NIL> e_info;
typedef face_2_info<Cdouble,NIL> f_info;
typedef PEG2<v_info,e_info,f_info> Gtype;

void handle(bool ok_flag)
{
  if (ok_flag)
    cout << "ok" << endl;
  else
  {
    cout << "error" << endl;
    exit(0);
  }
}
    
main()
{
  Gtype G1;

  Gtype::Vertex_2 v0(0,0), v1(1,1);
  Gtype::Vertex_2 *pV0, *pV1;
  Gtype::Face_2 *pF0;

  cout << "add infinity face ";
  handle(G1.add_infinity_face(pF0));
  
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v0,pV0));
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v1,pV1));
  G1.print_subdivision();
  
  cout << "point abstraction ";
  handle(G1.point_abstraction(pV0));
  cout << "point abstraction ";
  handle(G1.point_abstraction(pV1));
  G1.print_subdivision();
}

