// *******************************************************************
// *				      		  		     *
// * TEST PER expand_line_to_region() e region_to_line_contraction() *
// *				     				     *
// *******************************************************************
#include <CGAL/Cartesian.h>
#include <CGAL/Homogeneous.h>

// Rappresentazione dei punti:
typedef CGAL_Cartesian<double> Cdouble;

#include <peg2_info.h>
#include <peg2.h>

// Per comodita' ...
typedef vertex_2_info<Cdouble,NIL> v_info;
typedef edge_2_info<NIL> e_info;
typedef face_2_info<Cdouble,NIL> f_info;
typedef PEG2<v_info,e_info,f_info> Gtype;

void handle(bool ok_flag)
{
  if (ok_flag)
    cout << "ok" << endl;
  else
  {
    cout << "error" << endl;
    exit(0);
  }
}

main()
{
  Gtype G1;

  Gtype::Vertex_2 v0(1,2), v1(1,3); 
  Gtype::Vertex_2 *pV0, *pV1;
  Gtype::Edge_2 *pE0, *pEx;
  Gtype::Face_2 *pF0, *pF1, *pF2, *pF3;

  cout << "add infinity face ";
  handle(G1.add_infinity_face(pF0));
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v0,pV0));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV0,NULL,NULL,v0,pV0,v1,pV1,pE0));
  cout << "expand line to region ";
  handle(G1.expand_line_to_region(pE0,pF1,pEx));
  cout << "expand line to region ";
  handle(G1.expand_line_to_region(pE0,pF2,pEx));
  cout << "expand line to region ";
  handle(G1.expand_line_to_region(pE0,pF3,pEx));
  G1.print_subdivision();
  
  cout << "region to line contraction ";
  handle(G1.region_to_line_contraction(pF1,pEx));
  cout << "region to line contraction ";
  handle(G1.region_to_line_contraction(pF3,pEx));  
  G1.print_subdivision();
}

