// *****************************************************************
// *				      				   *
// * TEST PER expand_point_to_line() e line_to_point_contraction() *
// *				     				   *
// *****************************************************************

#include <CGAL/Cartesian.h>
#include <CGAL/Homogeneous.h>

// Rappresentazione dei punti:
typedef CGAL_Cartesian<double> Cdouble;

#include <peg2_info.h>
#include <peg2.h>

// Per comodita' ...
typedef vertex_2_info<Cdouble,NIL> v_info;
typedef edge_2_info<NIL> e_info;
typedef face_2_info<Cdouble,NIL> f_info;
typedef PEG2<v_info,e_info,f_info> Gtype;

void handle(bool ok_flag)
{
  if (ok_flag)
    cout << "ok" << endl;
  else
  {
    cout << "error" << endl;
    exit(0);
  }
}

main()
{
  Gtype G1;

  Gtype::Vertex_2 v0(0,0), v1(1,0), v2(2,0), v3(1,1); 
  Gtype::Vertex_2 *pV0, *pV1, *pV2, *pV3;
  Gtype::Edge_2 *pE0, *pE1, *pE2, *pE3, *pE4;
  Gtype::Face_2 *pF0, *pF1, *pF2;

  cout << "add infinity face ";
  handle(G1.add_infinity_face(pF0));
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v0,pV0));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV0,NULL,NULL,v0,pV0,v1,pV1,pE0));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV1,pE0,NULL,v1,pV1,v2,pV2,pE1));
  cout << "expand line to region ";
  handle(G1.expand_line_to_region(pE0,pF1,pE2));
  cout << "expand line to region ";
  handle(G1.expand_line_to_region(pE1,pF2,pE3));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV1,pE1,pE2,v1,pV1,v3,pV3,pE4));
  G1.print_subdivision();

  cout << "line to point contraction ";
  handle(G1.line_to_point_contraction(pE4,v1,pV1));
  G1.print_subdivision();
}

