// **************************************
// *			                *
// * TEST PER split_line e line_merge() *
// *			                *
// **************************************

#include <CGAL/Cartesian.h>
#include <CGAL/Homogeneous.h>

// Rappresentazione dei punti:
typedef CGAL_Cartesian<double> Cdouble;

#include <peg2_info.h>
#include <peg2.h>

// Per comodita' ...
typedef vertex_2_info<Cdouble,NIL> v_info;
typedef edge_2_info<NIL> e_info;
typedef face_2_info<Cdouble,NIL> f_info;
typedef PEG2<v_info,e_info,f_info> Gtype;

void handle(bool ok_flag)
{
  if (ok_flag)
    cout << "ok" << endl;
  else
  {
    cout << "error" << endl;
    exit(0);
  }
}

main()
{
  Gtype G1;

  Gtype::Vertex_2 v0(1,0), v1(3,0), v2(1,1), v3(1,-1), v4(3,1), v5(3,-1); 
  Gtype::Vertex_2 v6(2,0);
  Gtype::Vertex_2 *pV0, *pV1, *pV2, *pV3, *pV4, *pV5, *pV6;
  Gtype::Edge_2 *pE0, *pE1, *pE2, *pE3, *pE4, *pE5;
  Gtype::Face_2 *pF0;

  cout << "add infinity face ";
  handle(G1.add_infinity_face(pF0));
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v0,pV0));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV0,NULL,NULL,v0,pV0,v1,pV1,pE0));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV0,pE0,NULL,v0,pV0,v2,pV2,pE1));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV0,pE1,NULL,v0,pV0,v3,pV3,pE2));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV1,pE0,NULL,v1,pV1,v5,pV5,pE3));
  cout << "expand point to line ";
  handle(G1.expand_point_to_line(pV1,pE3,NULL,v1,pV1,v4,pV4,pE4));
  cout << "split line ";
  handle(G1.split_line(pE0,v6,pV6,pE5));
  G1.print_subdivision();
  
  cout << "merge line ";
  handle(G1.line_merge(pV6,pE4));
  G1.print_subdivision();  
}

