// **************************************
// *			                *
// * TEST PER split_line e line_merge() *
// *			                *
// **************************************

#include <CGAL/Cartesian.h>
#include <CGAL/Homogeneous.h>

// Rappresentazione dei punti:
typedef CGAL_Cartesian<double> Cdouble;

#include <peg2_info.h>
#include <peg2.h>

// Per comodita' ...
typedef vertex_2_info<Cdouble,NIL> v_info;
typedef edge_2_info<NIL> e_info;
typedef face_2_info<Cdouble,NIL> f_info;
typedef PEG2<v_info,e_info,f_info> Gtype;

void handle(bool ok_flag)
{
  if (ok_flag)
    cout << "ok" << endl;
  else
  {
    cout << "error" << endl;
    exit(0);
  }
}

main()
{
  Gtype G1;

  Gtype::Vertex_2 v0(1,0), v1(2,0), v2(2,1); 
  Gtype::Vertex_2 *pV0, *pV1, *pV2;
  Gtype::Edge_2 *pE0, *pE1, *pE2;
  Gtype::Face_2 *pF0, *pF1;

  cout << "add infinity face ";
  handle(G1.add_infinity_face(pF0));
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v0,pV0));
  cout << "expand point to region ";
  handle(G1.expand_point_to_region(pV0,NULL,pF0,pE0,pF1));
  cout << "split line ";
  handle(G1.split_line(pE0,v1,pV1,pE1));
  cout << "split line ";
  handle(G1.split_line(pE1,v2,pV2,pE2));
  G1.print_subdivision();

  cout << "merge line ";
  handle(G1.line_merge(pV2,pE1));
  cout << "merge line ";
  handle(G1.line_merge(pV1,pE0));
  G1.print_subdivision();
}

