// ********************************************
// *			         	      *
// * TEST PER split_region() e region_merge() *
// *			         	      *
// ********************************************

#include <CGAL/Cartesian.h>
#include <CGAL/Homogeneous.h>

// Rappresentazione dei punti:
typedef CGAL_Cartesian<double> Cdouble;

#include <peg2_info.h>
#include <peg2.h>

// Per comodita' ...
typedef vertex_2_info<Cdouble,NIL> v_info;
typedef edge_2_info<NIL> e_info;
typedef face_2_info<Cdouble,NIL> f_info;
typedef PEG2<v_info,e_info,f_info> Gtype;

void handle(bool ok_flag)
{
  if (ok_flag)
    cout << "ok" << endl;
  else
  {
    cout << "error" << endl;
    exit(0);
  }
}

main()
{
  Gtype G1;

  Gtype::Vertex_2 v0(0,0), v1(3,0); 
  Gtype::Vertex_2 *pV0, *pV1;
  Gtype::Edge_2 *pE0, *pE1, *pE2;
  Gtype::Face_2 *pF0, *pF1, *pF2;

  cout << "add infinity face ";
  handle(G1.add_infinity_face(pF0));
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v0,pV0));
  cout << "add point feature ";
  handle(G1.add_point_feature(pF0,v1,pV1));
  cout << "add line feature ";
  handle(G1.add_line_feature(pV0,pV1,NULL,NULL,pE0));
  cout << "expand line to region ";
  handle(G1.expand_line_to_region(pE0,pF1,pE1));
  cout << "split region ";
  handle(G1.split_region(pF1,pV0,pV1,pE2,pF2));
  G1.print_subdivision();
  
  cout << "region merge ";
  handle(G1.region_merge(pE2,pF2));
  G1.print_subdivision();
}

